/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Save and restore-directory functions                                   *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "prog.h"
#include "dr.h"
#include "alc.h"

int pascal Save_Dir(char *orig_disk,char *orig_path[],char *path)
{
  char temp[PATHLEN],
       dn,
       *p;

  if (*orig_disk==-1)
    *orig_disk=(char)getdisk();

  strcpy(temp,path);

  if (isalpha(*temp) && temp[1]==':')
    dn=toupper(*temp)-'A';
  else dn=(char)getdisk();

  if (! orig_path[dn])  /* Do this if it's NULL, otherwise skip it */
  {
    setdisk(dn);

    if (getdisk() != dn) /* If we didn't change drives successfully... */
      return 0;          /* We return 0 because -1 indicates out of memory */
    else
    {
      if ((orig_path[dn]=(char *)malloc(PATHLEN))==NULL)
        return -1;

      if (getcwd(orig_path[dn],PATHLEN)==NULL)
        orig_path[dn]=NULL;
    }
  }

  if (strlen(temp) > 3 && temp[strlen(temp)-1]=='\\')
    temp[strlen(temp)-1]='\0';

  /* Now change to the right directory... */
  if ((p=strchr(temp,':')) != NULL)
  {
    if (p==temp+1)
    {
      setdisk(toupper(*temp)-'A');
      chdir(temp+2);
    }
  }
  else chdir(temp);

  return 0;
}



void pascal Restore_Dir(char *orig_disk,char *orig_path[])
{
  int x;

  for (x=0;x < MAX_DRIVES;x++)
  {
    if (orig_path[x] && ! isnl(orig_path[x]))
    {
      chdir(orig_path[x]);

      free(orig_path[x]);
      orig_path[x]=NULL;
    }
  }

  setdisk(*orig_disk);

  *orig_disk=-1;
}




